#!/usr/bin/perl -w
## ######### PROJECT NAME : ##########
## 
## Bonding.pm for bonding in /usr/local/lib/site_perl
## 
## ######### PROJECT DESCRIPTION : ###
## 
## librairie de configuration du bonding
## 
## ###################################
## 
## Made by husianycia cedric
## Login   <root@intellique.com>
## 
## Started on  Wed Jun  8 09:59:02 2005 husianycia cedric
## Last update Mon Jun 20 09:49:25 2005 husianycia cedric
## 
## ###################################
##

my	$Version = "1.01-6";

#############################################################
## Libs

package		Bonding;
use		strict;
use		Objet_Conf;		# Objet de Conf Intellique
	
#############################################################
## Declaration de variables

		# Objet Conf
my	$conf;
		# Chemin du fichier de configuration
my	$path_conf	= "/etc/storiq/bonding.ini";
		# Objet Event
my	$event;

#############################################################
## Fonction qui retourne la version de ce package

sub	get_version{
    return ($Version);
}

#############################################################
## set_infos, prend une hash

sub	set_info {
    main();
    
    my %hash = @_;
    my $max_bonds = 0;
    
    foreach my $keys (keys(%{$hash{"bondlist_mode"}})) {
    	my $flag = 0;
	if ($hash{"bondlist_mode"}{$keys} =~ m/deleted/ ||
	    $hash{"bondlist_mode"}{$keys} eq "")
	{
	    $conf->delete($keys, "bondlist_mode");
	    $flag = 1;
	}
	
	$max_bonds++;
	if ($flag == 0){
	    unless (defined($conf->set_value_file($keys, $hash{"bondlist_mode"}{$keys}, "bondlist_mode")))
	    {
		$conf->set_new_value_file($keys, $hash{"bondlist_mode"}{$keys}, "bondlist_mode");
	    }
    	}
	
	my @interfaces = `cat /etc/network/interfaces`;
	
	open (IFACE, "> /etc/network/interfaces");
	
	my $cpt = 0;
	
	foreach (@interfaces){
	    
	    #on remet le cpt a 0 si on entre ds une nouvelle zone d'interface
	    if ($_ =~ m/iface/)
	    {
		$cpt = 0;
		my @tmp2 = split(" ", $_);
		my $bond = $tmp2[1];	
		if ($bond =~ m/bond/)
		{
		    if ($hash{"bondlist_mode"}{$bond} eq "deleted" ||
			$hash{"bondlist_mode"}{$bond} eq ""){
			$cpt = 1;
		    }
		}
		
	    }
	    #on le met a 1 si c'est le bond et que c'est une interface supprime
	    if ($_ =~ m/iface $keys/ && $flag == 1)
	    {
		$cpt = 1;	
	    }
	    if ($_ =~ m/^auto/)
	    {
		if ($hash{actived} == 0 && $flag == 0){
		    $_ =~ s/$keys//;
		    print IFACE $_;
		}
		else
		{
		    chomp ($_);
		    if ($_ !~ m/$keys/ && $flag == 0)
		    {
			$_ .= " $keys";
			my $inter = $hash{"bondlist_mode"}{$keys};
			my @tabint = split (",", $inter);
			foreach $inter (@tabint){
			    if ($inter && $inter !~ /\s/g){
				$_ =~ s/\s$inter//;
			    }
			}
		    }
		    my @tmp = split(" ", $_);
		    foreach my $bond (@tmp)
		    {
			if ($bond =~ m/bond/)
			{
			    if ($hash{"bondlist_mode"}{$bond} eq "deleted" ||
				$hash{"bondlist_mode"}{$bond} eq ""){
				$_ =~ s/$bond//;
			    }
			}
		    }
		    print IFACE $_."\n";
		}
	    }
	    elsif ($cpt == 0) {
		
		print IFACE $_;
	    } 
	}
	close (IFACE);
	
	if ($flag == 0){
	    unless (`cat /etc/network/interfaces | grep "iface $keys"`)
	    {
		`echo "iface $keys inet dhcp\n" >> /etc/network/interfaces`;
	    }
	}
    }
    
    delete($hash{"bondlist_mode"});
    
    foreach my $keys (keys(%hash)) {
	unless ($keys =~ m/^bond/){
	    #print $keys." ".$hash{$keys}."\n";
	    unless (defined($conf->set_value_file($keys, $hash{$keys}))){
		$conf->set_new_value_file($keys, $hash{$keys});
	    }
	}
    }
    #print $event->get_last_event();
    if (`lsmod | grep bonding`) {
	my @tab = `cat /etc/modules`;
	
	open (MODULES, "> /etc/modules");
	foreach (@tab){
	    if ($_ !~ m/bonding/) {
		print MODULES $_;
	    }
	}
	close (MODULES);
	
	my $miimon = $conf->get_value_file("miimon");
	my $mode_b = $conf->get_value_file("mode");
	`echo "bonding mode=$mode_b miimon=$miimon max_bonds=$max_bonds" >> /etc/modules`;
    }
    
    return (%hash);
}

#############################################################
## Get_infos, retourne une hash

sub	get_info {
    main();
    
    my %hash;
    my $line = "";
    
    my %hashtmp = $conf->get_all();
    %hash = %{$hashtmp{"DEFAUTINTELLIQUEUNIQUE"}};
    my %temp = %{$hashtmp{"bondlist_mode"}};
    
    $hash{"bondlist_mode"} = \%temp;
    
    foreach my $bond_name (keys(%temp)){
	$hash{$bond_name} = $temp{$bond_name};
	if ($line = `cat /etc/network/interfaces | grep $bond_name`) {
	    my @interfaces = `cat /etc/network/interfaces`;
	    my $cpt = 0;
	    
	    foreach (@interfaces){
		
		$cpt = 0 if ($_ =~ m/iface/);
		$cpt = 1 if ($_ =~ m/$bond_name/ && $cpt == 0);
		
	    }
	}
	if (`lsmod | grep bonding`) { 
	    
	    $line = `cat /etc/modules | grep bonding`;
	    
	    my @result = split(" ", $line);
	    
	    ## Parsing des options de bonding dans /etc/modules
	    ## modification du fichier de conf en fonction
	    foreach (@result)
	    {
		if ($_ =~ m/^(.*)=(.*)$/) {
		    $hash{$1} = $2;
		}
	    }
	}
    }
    return (%hash);
}


#############################################################
## retourne la liste des interfaces sur la machinnnneeeEEeee!
## (crier romain si ca marche pas)

sub give_interfaces{

    my %h;
    my @inter = `ls /proc/sys/net/ipv4/conf`;
    
    
    @inter = `ifconfig -a | cut -d " " -f1`;
    foreach (@inter) {
	chomp($_);

        $h{$_} = "" if ($_ and $_ ne "\n" and $_ ne "lo" and $_ !~ m/^bond/);
    }
   
    return (sort (keys(%h)));
}

#############################################################
## Main

sub	main {
    
    unless ($event = new Objet_Event())
    {
	print "Pb creation Objet_Event\n";
	exit 1;
    }
    unless ($conf = new Objet_Conf($event, $path_conf, "=", "#")) 
    {
	print "Pb creation Objet_Conf\n";
	exit 1;
    }
    $conf->init();
}

#############################################################
## APPEL du Main

main();

1;
